diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
index 1b96cab2b..176048d57 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
@@ -6,25 +6,27 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate mossOverlay;
+
     public BlockModelStoneMossy(Block<T> block) {
         super(block);
-        mossOverlay = TextureRegistry.getTexture("minecraft:block/moss_overlay");
+        this.mossOverlay = TextureRegistry.getTexture("minecraft:block/moss_overlay");
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
-        renderBlocks.overrideBlockTexture = mossOverlay;
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1.0f, 1.0f, 1.0f);
+        renderBlocks.overrideBlockTexture = this.mossOverlay;
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         renderBlocks.overrideBlockTexture = null;
         return true;
     }
@@ -36,14 +38,14 @@ public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStanda
         renderBlocks.useInventoryTint = true;
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-        float r = (float)(color >> 16 & 0xff) / 255F;
-        float g = (float)(color >> 8 & 0xff) / 255F;
-        float b = (float)(color & 0xff) / 255F;
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
         GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
 
-        AABB bounds = block.getBounds();
-        IconCoordinate mossCoord = mossOverlay;
+        AABBdc bounds = this.block.getBounds();
+        IconCoordinate mossCoord = this.mossOverlay;
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index b99e1643a..3c8aad47b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -8,8 +8,8 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicTorch;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelTorch(Block<T> block) {
@@ -17,13 +17,13 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-            if(block.emission > 0) {
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            if (this.block.emission > 0) {
                 brightness = 1.0F;
             }
         }
@@ -31,31 +31,30 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
-        int direction = worldSource.getBlockMetadata(x, y, z) & BlockLogicTorch.MASK_DIRECTION;
+        int direction = worldSource.getBlockData(tilePos) & BlockLogicTorch.MASK_DIRECTION;
         switch (direction) {
             case BlockLogicTorch.SIDE_WEST:
-                renderTorchAtAngle(tessellator, (double) x - d1, (double) y + d2, z, -d, 0.0D);
+                renderTorchAtAngle(tessellator, (double) tilePos.x() - d1, (double) tilePos.y() + d2, tilePos.z(), -d, 0.0D);
                 break;
             case BlockLogicTorch.SIDE_EAST:
-                renderTorchAtAngle(tessellator, (double) x + d1, (double) y + d2, z, d, 0.0D);
+                renderTorchAtAngle(tessellator, (double) tilePos.x() + d1, (double) tilePos.y() + d2, tilePos.z(), d, 0.0D);
                 break;
             case BlockLogicTorch.SIDE_NORTH:
-                renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z - d1, 0.0D, -d);
+                renderTorchAtAngle(tessellator, tilePos.x(), (double) tilePos.y() + d2, (double) tilePos.z() - d1, 0.0D, -d);
                 break;
             case BlockLogicTorch.SIDE_SOUTH:
-                renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z + d1, 0.0D, d);
+                renderTorchAtAngle(tessellator, tilePos.x(), (double) tilePos.y() + d2, (double) tilePos.z() + d1, 0.0D, d);
                 break;
             default:
-                renderTorchAtAngle(tessellator, x, y, z, 0.0D, 0.0D);
+                renderTorchAtAngle(tessellator, tilePos.x(), tilePos.y(), tilePos.z(), 0.0D, 0.0D);
                 break;
         }
         return true;
     }
-    public void renderTorchAtAngle(Tessellator tessellator, double x, double y, double z, double topOffsetX, double topOffsetZ)
-    {
+
+    public void renderTorchAtAngle(Tessellator tessellator, double x, double y, double z, double topOffsetX, double topOffsetZ) {
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, 0);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
         }
 
@@ -106,6 +105,7 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
         tessellator.addVertexWithUV(d9 + topOffsetX, y + 0.0D, (z - d13) + topOffsetZ, maxU, maxV);
         tessellator.addVertexWithUV(d9, y + 1.0D, z - d13, maxU, minV);
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
index 205245bb4..c04006598 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
@@ -16,19 +16,16 @@ public class BlockModelTorchRedstone<T extends BlockLogic> extends BlockModelTor
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if(side == Side.TOP)
-        {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (side == Side.TOP) {
             return redstoneWire.getBlockTextureFromSideAndMetadata(side, data);
-        } else
-        {
+        } else {
             return super.getBlockTextureFromSideAndMetadata(side, data);
         }
     }
 
     @Override
     public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta) {
-        return blockTextures.get(Side.NORTH);
+        return this.blockTextures.get(Side.NORTH);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
index eff666ee2..c7202598d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
@@ -3,25 +3,25 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelTransparent<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean renderInside;
-    public BlockModelTransparent(Block<T> block, boolean renderInside){
+
+    public BlockModelTransparent(Block<T> block, boolean renderInside) {
         super(block);
         this.renderInside = renderInside;
     }
+
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
-        if(!renderInside && blockAccess.getBlockId(x, y, z) == block.id())
-        {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (!this.renderInside && source.getBlockId(tilePos) == this.block.id()) {
             return false;
-        } else
-        {
-            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
+        } else {
+            return super.shouldSideBeRendered(source, bounds, tilePos, side);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 8096fe0a9..66be3fbd1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -21,11 +22,11 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int metadata = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int metadata = worldSource.getBlockData(tilePos);
         boolean isUp = BlockLogicTrapDoor.isTrapdoorOpen(metadata);
 
-        if(isUp) {
+        if (isUp) {
             switch (metadata & 3) {
                 case 0:
 
@@ -55,36 +56,36 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
                     renderBlocks.uvRotateWest = 1;
                     break;
             }
-        }
-        else{
-            if(BlockLogicTrapDoor.isUpperHalf(metadata)){
+        } else {
+            if (BlockLogicTrapDoor.isUpperHalf(metadata)) {
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
                 renderBlocks.uvRotateEast = 3;
                 renderBlocks.uvRotateWest = 3;
             }
         }
-        super.render(tessellator, worldSource, x, y, z);
+        super.render(tessellator, worldSource, tilePos);
         renderBlocks.resetRenderBlocks();
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(0, 0.25f, 0);
         super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         int orientation = data & 3;
-        if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
+        if (BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
-            return blockTextures.get(index);
+            return this.blockTextures.get(index);
         } else {
-            if(side.getAxis() == Axis.Y) {
-                return blockTextures.get(Side.BOTTOM);
-            }else {
-                return blockTextures.get(Side.SOUTH);
+            if (side.getAxis() == Axis.Y) {
+                return this.blockTextures.get(Side.BOTTOM);
+            } else {
+                return this.blockTextures.get(Side.SOUTH);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
index 2e5c882fb..4999bd1c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelTrapDoorPainted<T extends BlockLogic> extends BlockModelTrapDoor<T> {
@@ -16,27 +17,28 @@ public class BlockModelTrapDoorPainted<T extends BlockLogic> extends BlockModelT
     public static final IconCoordinate[] sideTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
-        for (DyeColor c : DyeColor.blockOrderedColors()){
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
             topTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor/planks_" + c.colorID + "/top");
             sideTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor/planks_" + c.colorID + "/side");
         }
     }
+
     public BlockModelTrapDoorPainted(Block<T> block) {
         super(block);
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         int orientation = data & 3;
-        if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
+        if (BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             if (index < 2) return topTextures[color];
             return sideTextures[color];
         } else {
-            if(side.getAxis() == Axis.Y) {
+            if (side.getAxis() == Axis.Y) {
                 return topTextures[color];
-            }else {
+            } else {
                 return sideTextures[color];
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 9613b9034..84eb9d1ae 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.BlockLogicVeryRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -26,8 +27,8 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        final int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        final int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(meta);
 
         if (dir == Direction.DOWN || dir == Direction.UP) {
@@ -39,7 +40,7 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
             renderBlocks.uvRotateTop = 1;
             renderBlocks.uvRotateBottom = 1;
         }
-        final boolean result = super.render(tessellator, worldSource, x, y, z);
+        final boolean result = super.render(tessellator, worldSource, tilePos);
         renderBlocks.resetRenderBlocks();
 
         return result;
@@ -55,13 +56,12 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(@NotNull Side side, int data) {
         return super.getBlockOverbrightTextureFromSideAndMeta(getRotatedSide(side, data), data);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         return super.getBlockTextureFromSideAndMetadata(getRotatedSide(side, data), data);
     }
 
